########## simulation runs (from original apm paper but now comparing Augmented Lagrangian and ConstOptim)
###############

################################ SIMULATIONS
set_logger <- function(inlevel) {
  
  if(!inlevel %in% list("DEBUG", "ERROR", "FATAL", "INFO", "TRACE", "WARNING")){
    rlog::log_error("Invalid log level")
    stop()
  }
  Sys.setenv("LOG_LEVEL" = inlevel)
  
  rlog::log_info(paste("logging has been set",inlevel))
  
}

test_it <- function(args) {
  set_logger(args[7])
  rlog::log_info(paste("beginning stub2 test it",args[2], args[3],args[4],args[5],args[6]))
  basedir <- args[1]
  
  # Run 10c or 2c depending on performance numbers you are looking to execute. 
  #sfile <- paste(basedir,'/source/R/Simulation_p10c.R',sep="")
  sfile <- paste(basedir,'/source/R/Simulation_p2c.R',sep="")
  source(sfile,keep.source=TRUE)
  
    
  case <- as.character(args[2])
  replicates  <- as.integer(args[3])
  sampleSize  <- as.integer(args[4])
  covariates  <- as.integer(args[5])
  seed  <- as.integer(args[6])
  
  currentDate <- format(Sys.Date(), "%m-%d-%y")
  
  rlog::log_debug(paste("calling execute tests",args[2], args[3],args[4],args[5],args[6], sep=" "))
  executeTests(case, replicates, sampleSize, covariates, seed, basedir)
  rlog::log_debug(paste("returned from execute tests",args[2], args[3],args[4],args[5],args[6], sep=" "))
  
}

#args <- c('E:/lcpm-test', 'E',10,500000,2,100,'TRACE')
args = commandArgs(trailingOnly=TRUE)
rlog::log_info(paste("calling test_it",args[2], args[3],args[4],args[5],args[6], args[7], sep=" "))

test_it(args)
