#' @title The Negative Log-Likelihood Function for a Log Cumulative Probability Model
#'
#' @description \code{lcpmMinusloglik} provides the negative of the log-likelihood function for a Generalized Linear Model with a log link and ordinal outcomes to be minimized in functions \code{\link{lcpm}} and \code{\link{ppm}}.
#' @param betapar a vector of values.
#' @param Xa1 matrix of covariates for all subjects with the lowest ordinal outcome value 1.
#' @param XaJ matrix of covariates for all subjects with the largest ordinal outcome value J.
#' @param Xaj1 matrix of covariates for all subjects with the ordinal outcomes with value 1 < j < J.
#' @param Xaj2 matrix of covariates for all subjects with the ordinal outcome with value 1 < j < J but lagged by 1.
#' 
#' @return value of the negative log-likelihood evaluated at betapar 
#' @export

minusloglikppm<-function(betapar,Xa1,XaJ, Xaj1, Xaj2,Xaf,...){

    output1 <- minusloglikppm100(betapar,Xa1,XaJ, Xaj1, Xaj2)
    
    return(output1)
    
  }
  
h<-function(betapar,Xa1,XaJ,Xaj1,Xaj2,Xaf,...){
  
  
#    f <- as.list(environment(), all.names=TRUE)
#    print(f)
    
    output2 <- h100(betapar,-Xaf)
    
    
    return(output2)
    
  }
  
# apm_deriv for scenario
apm_deriv <- function(betapar,...){  
  
    output3 <- apm_deriv100(betapar)
  
  return(output3)
}

