#include <RcppArmadillo.h>
//[[Rcpp::depends(RcppArmadillo)]]

using namespace Rcpp;

//[[Rcpp::export()]]

double minusloglikppm( arma::vec & betapar, arma::imat & Xa1, arma::imat & XaJ, arma::imat & Xaj1, arma::imat & Xaj2, arma::imat & Xaf) {
         arma::uword Xa1_cols = Xa1.n_cols;
         arma::uword Xa1_rows = Xa1.n_rows;
         double loglik_1 = as_scalar(Xa1.col(Xa1_cols-1).t() * (Xa1.submat(0,0,Xa1_rows-1, Xa1_cols-2)\
                                                         * betapar));
         arma::uword XaJ_cols = XaJ.n_cols;
         arma::uword XaJ_rows = XaJ.n_rows;
         double loglik_J = as_scalar(XaJ.col(XaJ_cols-1).t() * log(1 - exp(XaJ.submat(0,0,XaJ_rows-1, Xa1_cols-2)\
                                                                    * betapar)));
         arma::uword Xaj1_cols = Xaj1.n_cols;
         arma::uword Xaj1_rows = Xaj1.n_rows;
         arma::uword Xaj2_cols = Xaj2.n_cols;
         arma::uword Xaj2_rows = Xaj2.n_rows;
         double loglik_j = as_scalar(Xaj1.col(Xaj1_cols-1).t() * log(exp(Xaj1.submat(0,0,Xaj1_rows-1, Xaj1_cols-2)\
                                                                  * betapar)\
                                                              - exp(Xaj2.submat(0,0,Xaj2_rows-1, Xaj2_cols-2) * betapar)));

         return arma::as_scalar(-(loglik_J + loglik_1 + loglik_j));  
}

//[[Rcpp::export()]]

arma::vec h(  arma::vec & betapar, arma::imat & Xa1, arma::imat & XaJ, arma::imat & Xaj1, arma::imat & Xaj2, arma::imat & Xaf) {
        return arma::vec(Xaf * betapar);  
}

//[[Rcpp::export()]]

arma::vec apm_deriv(  arma::vec & betapar, arma::imat & Xa1, arma::imat & XaJ, arma::imat & Xaj1, arma::imat & Xaj2, arma::imat & Xaf) {
  return betapar;
}
